var pt = Object.defineProperty;
var dt = (i, e, t) => e in i ? pt(i, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : i[e] = t;
var a = (i, e, t) => (dt(i, typeof e != "symbol" ? e + "" : e, t), t);
var ft = Object.defineProperty, mt = (i, e, t) => e in i ? ft(i, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : i[e] = t, h = (i, e, t) => (mt(i, typeof e != "symbol" ? e + "" : e, t), t);
function Et(i, e = !1) {
  if (i == null)
    throw new Error("Cannot clean a NULL value");
  return Array.isArray(i) ? i = i.filter((t) => t != null) : Object.entries(i).forEach(([t, r]) => {
    (e && r === void 0 || !e && r == null) && delete i[t];
  }), i;
}
function X(i, e) {
  const t = typeof i, r = typeof e;
  return t != "object" || i == null || r != "object" || e == null ? t == "function" && r == "function" ? i.toString() == e.toString() : i === e : Object.keys(i).length != Object.keys(e).length ? !1 : Object.keys(i).every((s) => X(i[s], e[s]));
}
function yt(i, e) {
  const t = document.createElement("a");
  t.href = i, t.download = e, document.body.appendChild(t), t.click(), document.body.removeChild(t);
}
class p {
  constructor() {
    h(this, "listeners", {});
  }
  static emit(e, ...t) {
    (this.listeners["*"] || []).forEach((r) => r(e, ...t)), (this.listeners[e.toString()] || []).forEach((r) => r(...t));
  }
  static off(e, t) {
    const r = e.toString();
    this.listeners[r] = (this.listeners[r] || []).filter((s) => s === t);
  }
  static on(e, t) {
    var r;
    const s = e.toString();
    return this.listeners[s] || (this.listeners[s] = []), (r = this.listeners[s]) == null || r.push(t), () => this.off(e, t);
  }
  static once(e, t) {
    return new Promise((r) => {
      const s = this.on(e, (...n) => {
        r(n.length == 1 ? n[0] : n), t && t(...n), s();
      });
    });
  }
  emit(e, ...t) {
    (this.listeners["*"] || []).forEach((r) => r(e, ...t)), (this.listeners[e] || []).forEach((r) => r(...t));
  }
  off(e, t) {
    this.listeners[e] = (this.listeners[e] || []).filter((r) => r === t);
  }
  on(e, t) {
    var r;
    return this.listeners[e] || (this.listeners[e] = []), (r = this.listeners[e]) == null || r.push(t), () => this.off(e, t);
  }
  once(e, t) {
    return new Promise((r) => {
      const s = this.on(e, (...n) => {
        r(n.length == 1 ? n[0] : n), t && t(...n), s();
      });
    });
  }
}
h(p, "listeners", {});
const C = class b {
  constructor(e = {}) {
    h(this, "interceptors", {}), h(this, "headers", {}), this.opts = e, this.headers = e.headers || {}, e.interceptors && e.interceptors.forEach((t) => b.addInterceptor(t));
  }
  static addInterceptor(e) {
    const t = Object.keys(b.interceptors).length.toString();
    return b.interceptors[t] = e, () => {
      b.interceptors[t] = null;
    };
  }
  addInterceptor(e) {
    const t = Object.keys(this.interceptors).length.toString();
    return this.interceptors[t] = e, () => {
      this.interceptors[t] = null;
    };
  }
  async request(e = {}) {
    var t, r;
    if (!this.opts.url && !e.url)
      throw new Error("URL needs to be set");
    const s = ((t = e.url) != null && t.startsWith("http") ? e.url : (this.opts.url || "") + (e.url || "")).replace(/([^:]\/)\/+/g, "$1"), n = Et({
      "Content-Type": e.body && !(e.body instanceof FormData) ? "application/json" : void 0,
      ...b.headers,
      ...this.headers,
      ...e.headers
    });
    return fetch(s, {
      headers: n,
      method: e.method || (e.body ? "POST" : "GET"),
      body: (r = n["Content-Type"]) != null && r.startsWith("application/json") && e.body ? JSON.stringify(e.body) : e.body
    }).then(async (o) => {
      var u, c;
      for (let f of [...Object.values(b.interceptors), ...Object.values(this.interceptors)])
        await new Promise((w) => f(o, () => w()));
      if (!o.ok)
        throw new Error(o.statusText);
      return !e.skipConverting && (u = o.headers.get("Content-Type")) != null && u.startsWith("application/json") ? await o.json() : !e.skipConverting && (c = o.headers.get("Content-Type")) != null && c.startsWith("text/plain") ? await o.text() : o;
    });
  }
};
h(C, "interceptors", {}), h(C, "headers", {});
let Z = C;
Z.addInterceptor((i, e) => {
  if (i.status == 200)
    return e();
  throw i.status == 400 ? new tt(i.statusText) : i.status == 401 ? new et(i.statusText) : i.status == 403 ? new rt(i.statusText) : i.status == 404 ? new it(i.statusText) : i.status == 500 ? new st(i.statusText) : new v(i.statusText, i.status);
});
class v extends Error {
  constructor(e, t) {
    super(e), h(this, "_code"), t != null && (this._code = t);
  }
  get code() {
    return this._code || this.constructor.code;
  }
  set code(e) {
    this._code = e;
  }
  static from(e) {
    const t = Number(e.statusCode) ?? Number(e.code), r = new this(e.message || e.toString());
    return Object.assign(r, {
      stack: e.stack,
      ...e,
      code: t ?? void 0
    });
  }
  static instanceof(e) {
    return e.constructor.code != null;
  }
  toString() {
    return this.message || super.toString();
  }
}
h(v, "code", 500);
class tt extends v {
  constructor(e = "Bad Request") {
    super(e);
  }
  static instanceof(e) {
    return e.constructor.code == this.code;
  }
}
h(tt, "code", 400);
class et extends v {
  constructor(e = "Unauthorized") {
    super(e);
  }
  static instanceof(e) {
    return e.constructor.code == this.code;
  }
}
h(et, "code", 401);
class rt extends v {
  constructor(e = "Forbidden") {
    super(e);
  }
  static instanceof(e) {
    return e.constructor.code == this.code;
  }
}
h(rt, "code", 403);
class it extends v {
  constructor(e = "Not Found") {
    super(e);
  }
  static instanceof(e) {
    return e.constructor.code == this.code;
  }
}
h(it, "code", 404);
class st extends v {
  constructor(e = "Internal Server Error") {
    super(e);
  }
  static instanceof(e) {
    return e.constructor.code == this.code;
  }
}
h(st, "code", 500);
const O = {
  CLEAR: "\x1B[0m",
  BRIGHT: "\x1B[1m",
  DIM: "\x1B[2m",
  UNDERSCORE: "\x1B[4m",
  BLINK: "\x1B[5m",
  REVERSE: "\x1B[7m",
  HIDDEN: "\x1B[8m"
}, $ = {
  BLACK: "\x1B[30m",
  RED: "\x1B[31m",
  GREEN: "\x1B[32m",
  YELLOW: "\x1B[33m",
  BLUE: "\x1B[34m",
  MAGENTA: "\x1B[35m",
  CYAN: "\x1B[36m",
  LIGHT_GREY: "\x1B[37m",
  GREY: "\x1B[90m",
  LIGHT_RED: "\x1B[91m",
  LIGHT_GREEN: "\x1B[92m",
  LIGHT_YELLOW: "\x1B[93m",
  LIGHT_BLUE: "\x1B[94m",
  LIGHT_MAGENTA: "\x1B[95m",
  LIGHT_CYAN: "\x1B[96m",
  WHITE: "\x1B[97m"
};
var L = /* @__PURE__ */ ((i) => (i[i.ERROR = 0] = "ERROR", i[i.WARN = 1] = "WARN", i[i.INFO = 2] = "INFO", i[i.LOG = 3] = "LOG", i[i.DEBUG = 4] = "DEBUG", i))(L || {});
const gt = class m extends p {
  constructor(e) {
    super(), this.namespace = e;
  }
  pad(e, t, r, s = !1) {
    const n = e.toString(), o = t - n.length;
    if (o <= 0)
      return n;
    const u = Array(~~(o / r.length)).fill(r).join("");
    return s ? n + u : u + n;
  }
  format(...e) {
    const t = /* @__PURE__ */ new Date();
    return `${`${t.getFullYear()}-${t.getMonth() + 1}-${t.getDate()} ${this.pad(t.getHours().toString(), 2, "0")}:${this.pad(t.getMinutes().toString(), 2, "0")}:${this.pad(t.getSeconds().toString(), 2, "0")}.${this.pad(t.getMilliseconds().toString(), 3, "0", !0)}`}${this.namespace ? ` [${this.namespace}]` : ""} ${e.join(" ")}`;
  }
  debug(...e) {
    if (m.LOG_LEVEL < 4)
      return;
    const t = this.format(...e);
    m.emit(4, t), console.debug($.LIGHT_GREY + t + O.CLEAR);
  }
  log(...e) {
    if (m.LOG_LEVEL < 3)
      return;
    const t = this.format(...e);
    m.emit(3, t), console.log(O.CLEAR + t);
  }
  info(...e) {
    if (m.LOG_LEVEL < 2)
      return;
    const t = this.format(...e);
    m.emit(2, t), console.info($.BLUE + t + O.CLEAR);
  }
  warn(...e) {
    if (m.LOG_LEVEL < 1)
      return;
    const t = this.format(...e);
    m.emit(1, t), console.warn($.YELLOW + t + O.CLEAR);
  }
  error(...e) {
    if (m.LOG_LEVEL < 0)
      return;
    const t = this.format(...e);
    m.emit(0, t), console.error($.RED + t + O.CLEAR);
  }
};
h(gt, "LOG_LEVEL", 4);
class bt extends Promise {
  constructor(e) {
    super((t, r) => e(
      (s) => t(s),
      (s) => r(s),
      (s) => this.progress = s
    )), h(this, "listeners", []), h(this, "_progress", 0);
  }
  get progress() {
    return this._progress;
  }
  set progress(e) {
    e != this._progress && (this._progress = e, this.listeners.forEach((t) => t(e)));
  }
  onProgress(e) {
    return this.listeners.push(e), this;
  }
}
class d extends Z {
  constructor(t = location.origin, r = {}) {
    r.url = t;
    super(r);
    a(this, "emitter", new p());
    a(this, "_token", null);
    a(this, "emit", this.emitter.emit.bind(this.emitter));
    a(this, "off", this.emitter.off.bind(this.emitter));
    a(this, "on", this.emitter.on.bind(this.emitter));
    a(this, "once", this.emitter.once.bind(this.emitter));
    this.url = t, this.opts = r;
  }
  get token() {
    return this._token;
  }
  set token(t) {
    t != this._token && (this._token = t, this.headers.Authorization = `Bearer ${t}`, this.emit("TOKEN", t));
  }
  request(t) {
    const r = super.request(t).then((s) => (this.emit("RESPONSE", s, t), s)).catch((s) => {
      throw this.emit("REJECTED", s, t), s;
    });
    return this.emit("REQUEST", r, t), r;
  }
}
var j = function(i, e) {
  return j = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(t, r) {
    t.__proto__ = r;
  } || function(t, r) {
    for (var s in r)
      Object.prototype.hasOwnProperty.call(r, s) && (t[s] = r[s]);
  }, j(i, e);
};
function x(i, e) {
  if (typeof e != "function" && e !== null)
    throw new TypeError("Class extends value " + String(e) + " is not a constructor or null");
  j(i, e);
  function t() {
    this.constructor = i;
  }
  i.prototype = e === null ? Object.create(e) : (t.prototype = e.prototype, new t());
}
function k(i) {
  var e = typeof Symbol == "function" && Symbol.iterator, t = e && i[e], r = 0;
  if (t)
    return t.call(i);
  if (i && typeof i.length == "number")
    return {
      next: function() {
        return i && r >= i.length && (i = void 0), { value: i && i[r++], done: !i };
      }
    };
  throw new TypeError(e ? "Object is not iterable." : "Symbol.iterator is not defined.");
}
function G(i, e) {
  var t = typeof Symbol == "function" && i[Symbol.iterator];
  if (!t)
    return i;
  var r = t.call(i), s, n = [], o;
  try {
    for (; (e === void 0 || e-- > 0) && !(s = r.next()).done; )
      n.push(s.value);
  } catch (u) {
    o = { error: u };
  } finally {
    try {
      s && !s.done && (t = r.return) && t.call(r);
    } finally {
      if (o)
        throw o.error;
    }
  }
  return n;
}
function N(i, e, t) {
  if (t || arguments.length === 2)
    for (var r = 0, s = e.length, n; r < s; r++)
      (n || !(r in e)) && (n || (n = Array.prototype.slice.call(e, 0, r)), n[r] = e[r]);
  return i.concat(n || Array.prototype.slice.call(e));
}
function y(i) {
  return typeof i == "function";
}
function nt(i) {
  var e = function(r) {
    Error.call(r), r.stack = new Error().stack;
  }, t = i(e);
  return t.prototype = Object.create(Error.prototype), t.prototype.constructor = t, t;
}
var U = nt(function(i) {
  return function(t) {
    i(this), this.message = t ? t.length + ` errors occurred during unsubscription:
` + t.map(function(r, s) {
      return s + 1 + ") " + r.toString();
    }).join(`
  `) : "", this.name = "UnsubscriptionError", this.errors = t;
  };
});
function H(i, e) {
  if (i) {
    var t = i.indexOf(e);
    0 <= t && i.splice(t, 1);
  }
}
var P = function() {
  function i(e) {
    this.initialTeardown = e, this.closed = !1, this._parentage = null, this._finalizers = null;
  }
  return i.prototype.unsubscribe = function() {
    var e, t, r, s, n;
    if (!this.closed) {
      this.closed = !0;
      var o = this._parentage;
      if (o)
        if (this._parentage = null, Array.isArray(o))
          try {
            for (var u = k(o), c = u.next(); !c.done; c = u.next()) {
              var f = c.value;
              f.remove(this);
            }
          } catch (l) {
            e = { error: l };
          } finally {
            try {
              c && !c.done && (t = u.return) && t.call(u);
            } finally {
              if (e)
                throw e.error;
            }
          }
        else
          o.remove(this);
      var w = this.initialTeardown;
      if (y(w))
        try {
          w();
        } catch (l) {
          n = l instanceof U ? l.errors : [l];
        }
      var T = this._finalizers;
      if (T) {
        this._finalizers = null;
        try {
          for (var g = k(T), E = g.next(); !E.done; E = g.next()) {
            var _ = E.value;
            try {
              V(_);
            } catch (l) {
              n = n ?? [], l instanceof U ? n = N(N([], G(n)), G(l.errors)) : n.push(l);
            }
          }
        } catch (l) {
          r = { error: l };
        } finally {
          try {
            E && !E.done && (s = g.return) && s.call(g);
          } finally {
            if (r)
              throw r.error;
          }
        }
      }
      if (n)
        throw new U(n);
    }
  }, i.prototype.add = function(e) {
    var t;
    if (e && e !== this)
      if (this.closed)
        V(e);
      else {
        if (e instanceof i) {
          if (e.closed || e._hasParent(this))
            return;
          e._addParent(this);
        }
        (this._finalizers = (t = this._finalizers) !== null && t !== void 0 ? t : []).push(e);
      }
  }, i.prototype._hasParent = function(e) {
    var t = this._parentage;
    return t === e || Array.isArray(t) && t.includes(e);
  }, i.prototype._addParent = function(e) {
    var t = this._parentage;
    this._parentage = Array.isArray(t) ? (t.push(e), t) : t ? [t, e] : e;
  }, i.prototype._removeParent = function(e) {
    var t = this._parentage;
    t === e ? this._parentage = null : Array.isArray(t) && H(t, e);
  }, i.prototype.remove = function(e) {
    var t = this._finalizers;
    t && H(t, e), e instanceof i && e._removeParent(this);
  }, i.EMPTY = function() {
    var e = new i();
    return e.closed = !0, e;
  }(), i;
}(), ot = P.EMPTY;
function ut(i) {
  return i instanceof P || i && "closed" in i && y(i.remove) && y(i.add) && y(i.unsubscribe);
}
function V(i) {
  y(i) ? i() : i.unsubscribe();
}
var at = {
  onUnhandledError: null,
  onStoppedNotification: null,
  Promise: void 0,
  useDeprecatedSynchronousErrorHandling: !1,
  useDeprecatedNextContext: !1
}, ct = {
  setTimeout: function(i, e) {
    for (var t = [], r = 2; r < arguments.length; r++)
      t[r - 2] = arguments[r];
    return setTimeout.apply(void 0, N([i, e], G(t)));
  },
  clearTimeout: function(i) {
    var e = ct.delegate;
    return ((e == null ? void 0 : e.clearTimeout) || clearTimeout)(i);
  },
  delegate: void 0
};
function vt(i) {
  ct.setTimeout(function() {
    throw i;
  });
}
function K() {
}
function R(i) {
  i();
}
var ht = function(i) {
  x(e, i);
  function e(t) {
    var r = i.call(this) || this;
    return r.isStopped = !1, t ? (r.destination = t, ut(t) && t.add(r)) : r.destination = Tt, r;
  }
  return e.create = function(t, r, s) {
    return new W(t, r, s);
  }, e.prototype.next = function(t) {
    this.isStopped || this._next(t);
  }, e.prototype.error = function(t) {
    this.isStopped || (this.isStopped = !0, this._error(t));
  }, e.prototype.complete = function() {
    this.isStopped || (this.isStopped = !0, this._complete());
  }, e.prototype.unsubscribe = function() {
    this.closed || (this.isStopped = !0, i.prototype.unsubscribe.call(this), this.destination = null);
  }, e.prototype._next = function(t) {
    this.destination.next(t);
  }, e.prototype._error = function(t) {
    try {
      this.destination.error(t);
    } finally {
      this.unsubscribe();
    }
  }, e.prototype._complete = function() {
    try {
      this.destination.complete();
    } finally {
      this.unsubscribe();
    }
  }, e;
}(P), wt = Function.prototype.bind;
function B(i, e) {
  return wt.call(i, e);
}
var St = function() {
  function i(e) {
    this.partialObserver = e;
  }
  return i.prototype.next = function(e) {
    var t = this.partialObserver;
    if (t.next)
      try {
        t.next(e);
      } catch (r) {
        A(r);
      }
  }, i.prototype.error = function(e) {
    var t = this.partialObserver;
    if (t.error)
      try {
        t.error(e);
      } catch (r) {
        A(r);
      }
    else
      A(e);
  }, i.prototype.complete = function() {
    var e = this.partialObserver;
    if (e.complete)
      try {
        e.complete();
      } catch (t) {
        A(t);
      }
  }, i;
}(), W = function(i) {
  x(e, i);
  function e(t, r, s) {
    var n = i.call(this) || this, o;
    if (y(t) || !t)
      o = {
        next: t ?? void 0,
        error: r ?? void 0,
        complete: s ?? void 0
      };
    else {
      var u;
      n && at.useDeprecatedNextContext ? (u = Object.create(t), u.unsubscribe = function() {
        return n.unsubscribe();
      }, o = {
        next: t.next && B(t.next, u),
        error: t.error && B(t.error, u),
        complete: t.complete && B(t.complete, u)
      }) : o = t;
    }
    return n.destination = new St(o), n;
  }
  return e;
}(ht);
function A(i) {
  vt(i);
}
function Lt(i) {
  throw i;
}
var Tt = {
  closed: !0,
  next: K,
  error: Lt,
  complete: K
}, Ot = function() {
  return typeof Symbol == "function" && Symbol.observable || "@@observable";
}();
function xt(i) {
  return i;
}
function _t(i) {
  return i.length === 0 ? xt : i.length === 1 ? i[0] : function(t) {
    return i.reduce(function(r, s) {
      return s(r);
    }, t);
  };
}
var z = function() {
  function i(e) {
    e && (this._subscribe = e);
  }
  return i.prototype.lift = function(e) {
    var t = new i();
    return t.source = this, t.operator = e, t;
  }, i.prototype.subscribe = function(e, t, r) {
    var s = this, n = At(e) ? e : new W(e, t, r);
    return R(function() {
      var o = s, u = o.operator, c = o.source;
      n.add(u ? u.call(n, c) : c ? s._subscribe(n) : s._trySubscribe(n));
    }), n;
  }, i.prototype._trySubscribe = function(e) {
    try {
      return this._subscribe(e);
    } catch (t) {
      e.error(t);
    }
  }, i.prototype.forEach = function(e, t) {
    var r = this;
    return t = J(t), new t(function(s, n) {
      var o = new W({
        next: function(u) {
          try {
            e(u);
          } catch (c) {
            n(c), o.unsubscribe();
          }
        },
        error: n,
        complete: s
      });
      r.subscribe(o);
    });
  }, i.prototype._subscribe = function(e) {
    var t;
    return (t = this.source) === null || t === void 0 ? void 0 : t.subscribe(e);
  }, i.prototype[Ot] = function() {
    return this;
  }, i.prototype.pipe = function() {
    for (var e = [], t = 0; t < arguments.length; t++)
      e[t] = arguments[t];
    return _t(e)(this);
  }, i.prototype.toPromise = function(e) {
    var t = this;
    return e = J(e), new e(function(r, s) {
      var n;
      t.subscribe(function(o) {
        return n = o;
      }, function(o) {
        return s(o);
      }, function() {
        return r(n);
      });
    });
  }, i.create = function(e) {
    return new i(e);
  }, i;
}();
function J(i) {
  var e;
  return (e = i ?? at.Promise) !== null && e !== void 0 ? e : Promise;
}
function $t(i) {
  return i && y(i.next) && y(i.error) && y(i.complete);
}
function At(i) {
  return i && i instanceof ht || $t(i) && ut(i);
}
var Rt = nt(function(i) {
  return function() {
    i(this), this.name = "ObjectUnsubscribedError", this.message = "object unsubscribed";
  };
}), lt = function(i) {
  x(e, i);
  function e() {
    var t = i.call(this) || this;
    return t.closed = !1, t.currentObservers = null, t.observers = [], t.isStopped = !1, t.hasError = !1, t.thrownError = null, t;
  }
  return e.prototype.lift = function(t) {
    var r = new Q(this, this);
    return r.operator = t, r;
  }, e.prototype._throwIfClosed = function() {
    if (this.closed)
      throw new Rt();
  }, e.prototype.next = function(t) {
    var r = this;
    R(function() {
      var s, n;
      if (r._throwIfClosed(), !r.isStopped) {
        r.currentObservers || (r.currentObservers = Array.from(r.observers));
        try {
          for (var o = k(r.currentObservers), u = o.next(); !u.done; u = o.next()) {
            var c = u.value;
            c.next(t);
          }
        } catch (f) {
          s = { error: f };
        } finally {
          try {
            u && !u.done && (n = o.return) && n.call(o);
          } finally {
            if (s)
              throw s.error;
          }
        }
      }
    });
  }, e.prototype.error = function(t) {
    var r = this;
    R(function() {
      if (r._throwIfClosed(), !r.isStopped) {
        r.hasError = r.isStopped = !0, r.thrownError = t;
        for (var s = r.observers; s.length; )
          s.shift().error(t);
      }
    });
  }, e.prototype.complete = function() {
    var t = this;
    R(function() {
      if (t._throwIfClosed(), !t.isStopped) {
        t.isStopped = !0;
        for (var r = t.observers; r.length; )
          r.shift().complete();
      }
    });
  }, e.prototype.unsubscribe = function() {
    this.isStopped = this.closed = !0, this.observers = this.currentObservers = null;
  }, Object.defineProperty(e.prototype, "observed", {
    get: function() {
      var t;
      return ((t = this.observers) === null || t === void 0 ? void 0 : t.length) > 0;
    },
    enumerable: !1,
    configurable: !0
  }), e.prototype._trySubscribe = function(t) {
    return this._throwIfClosed(), i.prototype._trySubscribe.call(this, t);
  }, e.prototype._subscribe = function(t) {
    return this._throwIfClosed(), this._checkFinalizedStatuses(t), this._innerSubscribe(t);
  }, e.prototype._innerSubscribe = function(t) {
    var r = this, s = this, n = s.hasError, o = s.isStopped, u = s.observers;
    return n || o ? ot : (this.currentObservers = null, u.push(t), new P(function() {
      r.currentObservers = null, H(u, t);
    }));
  }, e.prototype._checkFinalizedStatuses = function(t) {
    var r = this, s = r.hasError, n = r.thrownError, o = r.isStopped;
    s ? t.error(n) : o && t.complete();
  }, e.prototype.asObservable = function() {
    var t = new z();
    return t.source = this, t;
  }, e.create = function(t, r) {
    return new Q(t, r);
  }, e;
}(z), Q = function(i) {
  x(e, i);
  function e(t, r) {
    var s = i.call(this) || this;
    return s.destination = t, s.source = r, s;
  }
  return e.prototype.next = function(t) {
    var r, s;
    (s = (r = this.destination) === null || r === void 0 ? void 0 : r.next) === null || s === void 0 || s.call(r, t);
  }, e.prototype.error = function(t) {
    var r, s;
    (s = (r = this.destination) === null || r === void 0 ? void 0 : r.error) === null || s === void 0 || s.call(r, t);
  }, e.prototype.complete = function() {
    var t, r;
    (r = (t = this.destination) === null || t === void 0 ? void 0 : t.complete) === null || r === void 0 || r.call(t);
  }, e.prototype._subscribe = function(t) {
    var r, s;
    return (s = (r = this.source) === null || r === void 0 ? void 0 : r.subscribe(t)) !== null && s !== void 0 ? s : ot;
  }, e;
}(lt), I = function(i) {
  x(e, i);
  function e(t) {
    var r = i.call(this) || this;
    return r._value = t, r;
  }
  return Object.defineProperty(e.prototype, "value", {
    get: function() {
      return this.getValue();
    },
    enumerable: !1,
    configurable: !0
  }), e.prototype._subscribe = function(t) {
    var r = i.prototype._subscribe.call(this, t);
    return !r.closed && t.next(this._value), r;
  }, e.prototype.getValue = function() {
    var t = this, r = t.hasError, s = t.thrownError, n = t._value;
    if (r)
      throw s;
    return this._throwIfClosed(), n;
  }, e.prototype.next = function(t) {
    i.prototype.next.call(this, this._value = t);
  }, e;
}(lt), Dt = /* @__PURE__ */ ((i) => (i[i.DISABLED = 0] = "DISABLED", i[i.CRON = 1] = "CRON", i[i.EVENT = 2] = "EVENT", i[i.GET = 3] = "GET", i[i.POST = 4] = "POST", i[i.PATCH = 5] = "PATCH", i[i.PUT = 6] = "PUT", i[i.DELETE = 7] = "DELETE", i))(Dt || {});
class Pt extends p {
  constructor(t) {
    super();
    a(this, "api");
    a(this, "$cache", new I([]));
    this.api = typeof t == "string" ? new d(t) : t;
  }
  get cache() {
    return this.$cache.value;
  }
  set cache(t) {
    this.$cache.next(t);
  }
  delete(t) {
    return this.api.request({ url: `/api/actions/${t}`, method: "DELETE" }).then(() => {
      this.cache = this.cache.filter((r) => r._id != t), this.emit("DELETE", t);
    });
  }
  list() {
    return this.api.request({ url: "/api/actions" }).then((t) => (this.cache = t, this.emit("LIST", t), t));
  }
  read(t, r = !1) {
    const s = this.cache.find((n) => n._id == t);
    return !r && s ? Promise.resolve(s) : this.api.request({ url: `/api/actions/${t}` }).then((n) => (n && (this.cache = this.cache.filter((o) => o._id != t).concat([n])), this.emit("READ", n), n));
  }
  run(t, r = {}) {
    return this.api.request({ url: ("/api/actions/run/" + t).replaceAll("//", "/"), ...r });
  }
  runById(t, r = {}) {
    const s = typeof t == "string" ? t : t._id;
    return this.api.request({ url: "/api/actions/run-by-id/" + s, ...r });
  }
  update(t) {
    return this.api.request({
      url: `/api/actions${t._id ? `/${t._id}` : ""}`,
      method: "POST",
      body: t
    }).then((r) => (r && (this.cache = this.cache.filter((s) => s._id != r._id).concat([r])), this.emit("UPDATE", r), r));
  }
}
class It extends p {
  constructor(t, r) {
    var s;
    super();
    a(this, "api");
    a(this, "storageKey");
    a(this, "$user", new I(void 0));
    if (this.opts = r, this.api = typeof t == "string" ? new d(t) : t, (s = this.opts) != null && s.loginUi || (this.opts = { ...this.opts, loginUi: this.api.url + "/ui/login" }), this.storageKey = `momentum:${new URL(this.api.url).host}`, this.api.on("TOKEN", (n) => {
      var o;
      (o = this.opts) != null && o.persist && (n ? localStorage.setItem(this.storageKey, n) : localStorage.removeItem(this.storageKey)), n ? this.whoAmI(n, !0) : this.user = null;
    }), r != null && r.persist) {
      const n = localStorage.getItem(this.storageKey);
      n ? this.api.token = n : this.user = null;
    } else
      this.user = null;
  }
  get user() {
    return this.$user.value;
  }
  set user(t) {
    if (!X(this.user, t)) {
      const r = t || null;
      this.$user.next(r), this.emit("USER", r);
    }
  }
  knownHost(t = location.origin) {
    return t.startsWith("/") ? Promise.resolve() : this.api.request({ url: `/api/auth/known-host?host=${encodeURI(new URL(t).origin)}` });
  }
  login(t, r) {
    return this.api.request({
      url: "/api/auth/login",
      headers: { Authorization: void 0 },
      body: {
        username: t,
        password: r
      }
    }).then(async (s) => (this.api.token = s.token, await this.once("USER")));
  }
  loginRedirect(t = location.origin) {
    return new Promise((r, s) => {
      var o;
      const n = window.open(encodeURI(`${(o = this.opts) == null ? void 0 : o.loginUi}?redirect=postmessage&host=${t}`), "_blank");
      if (!n)
        return s("Unable to open login");
      n.addEventListener("message", (u) => {
        var c;
        if (!((c = u == null ? void 0 : u.data) != null && c.token))
          return s("Unknown response from login");
        this.api.token = u.data.token, r(u.data.token), n.close();
      });
    });
  }
  logout() {
    this.api.token = null, this.user = null, this.emit("LOGOUT");
  }
  async register(t) {
    const r = await this.api.request({ url: "/api/auth/register", body: { ...t } });
    return this.emit("REGISTER", t), r;
  }
  async reset(t, r) {
    await this.api.request({
      url: "/api/auth/reset",
      headers: { Authorization: r ? `Bearer ${r}` : void 0 },
      body: {
        email: r ? void 0 : t,
        password: r ? t : void 0
      }
    }), this.emit(r ? "RESET_COMPLETE" : "RESET_REQUEST", r || t);
  }
  async whoAmI(t, r = !1) {
    t || (t = this.api.token);
    const s = await this.api.request({
      url: "/api/auth/whoami",
      headers: t ? { Authorization: `Bearer ${t}` } : void 0
    });
    return r && (this.api.token = t, this.user = (s == null ? void 0 : s.user) || null, s && this.emit("LOGIN", s.user)), s;
  }
}
class qt extends p {
  constructor(t) {
    super();
    a(this, "api");
    this.api = typeof t == "string" ? new d(t) : t;
  }
  delete(t, r) {
    return this.api.request({
      url: `/api/data/${t}/${r}`,
      method: "DELETE"
    }).then(() => this.emit("DELETE", t, r));
  }
  get(t, r) {
    return this.api.request({ url: `/api/data/${t}${r ? `/${r}` : ""}` }).then((s) => (this.emit("GET", t, s), s));
  }
  raw(t, r, s, n) {
    return this.api.request({
      url: `/api/data/${t}`,
      body: {
        operand: r,
        query: s,
        options: n
      }
    }).then((o) => (this.emit("RAW", t, o), o));
  }
  set(t, r, s = !1) {
    return this.api.request({
      url: `/api/data/${t}/${r._id || ""}`,
      method: s ? "PATCH" : "POST",
      body: r
    }).then((n) => (this.emit("SET", t, r), n));
  }
}
class Ut extends p {
  constructor(t) {
    super();
    a(this, "api");
    this.api = typeof t == "string" ? new d(t) : t;
  }
  send(t) {
    let r = "/api/email/send";
    return typeof t.body == "object" && (r += `/${t.body.template}`), this.api.request({ url: r, body: t }).then((s) => (this.emit("SENT", t), s));
  }
}
class Bt extends p {
  constructor(t) {
    super();
    a(this, "api");
    this.api = typeof t == "string" ? new d(t) : t;
  }
  create(t) {
    return this.api.request({
      url: `/api/groups/${t.name}`,
      method: "POST",
      body: t
    }).then((r) => (this.emit("CREATE", r), r));
  }
  list() {
    return this.api.request({ url: "/api/groups" }).then((t) => (this.emit("LIST", t), t));
  }
  read(t) {
    return this.api.request({ url: `/api/groups/${t}` }).then((r) => (this.emit("READ", r), r));
  }
  update(t) {
    return this.api.request({
      url: `/api/groups/${t.name}`,
      method: "PATCH",
      body: t
    }).then((r) => (this.emit("UPDATE", r), r));
  }
  delete(t) {
    return this.api.request({
      url: `/api/groups/${t}`,
      method: "DELETE"
    }).then(() => this.emit("DELETE", t));
  }
}
class Ct {
  constructor(e, t) {
    a(this, "api");
    this.api = typeof e == "string" ? new d(e) : e, t != null && t != "NONE" && (window.addEventListener("error", (r) => this.error(r.error.stack)), window.addEventListener("unhandledrejection", async (r) => this.error(r.reason.stack)));
  }
  buildLog(e, t) {
    return {
      time: (/* @__PURE__ */ new Date()).getTime(),
      level: e,
      log: t,
      ctx: {
        url: location.href,
        res: [window.innerWidth, window.innerHeight]
      }
    };
  }
  clearClientLogs() {
    return this.api.request({ url: "/api/logs/client", method: "DELETE" });
  }
  clearServerLogs() {
    return this.api.request({ url: "/api/logs/server", method: "DELETE" });
  }
  clientLogs(e, t) {
    const r = [e ? `length=${e}` : void 0, t ? `page=${t}` : void 0].filter((s) => !!s).join("&");
    return this.api.request({ url: `/api/logs/client${r ? `?${r}` : ""}` });
  }
  serverLogs(e, t) {
    const r = [e ? `length=${e}` : void 0, t ? `page=${t}` : void 0].filter((s) => !!s).join("&");
    return this.api.request({ url: `/api/logs/server${r ? `?${r}` : ""}` });
  }
  debug(...e) {
    return this.api.request({ url: "/api/logs/client", body: this.buildLog(L.DEBUG, e) }).catch(() => {
    });
  }
  log(...e) {
    return this.api.request({ url: "/api/logs/client", body: this.buildLog(L.LOG, e) }).catch(() => {
    });
  }
  info(...e) {
    return this.api.request({ url: "/api/logs/client", body: this.buildLog(L.INFO, e) }).catch(() => {
    });
  }
  warn(...e) {
    return this.api.request({ url: "/api/logs/client", body: this.buildLog(L.WARN, e) }).catch(() => {
    });
  }
  error(...e) {
    return this.api.request({ url: "/api/logs/client", body: this.buildLog(L.ERROR, e) }).catch(() => {
    });
  }
}
const D = class D {
  constructor(e) {
    a(this, "api");
    a(this, "url");
    a(this, "connection");
    a(this, "open", !1);
    this.api = typeof e == "string" ? new d(e) : e, this.url = this.api.url.replace("http", "ws"), this.api.on("TOKEN", () => this.connect()), this.api.token || this.connect();
  }
  close() {
    console.debug("Disconnected from Momentum"), this.open = !1, this.connection.close();
  }
  connect(e = 3) {
    var r;
    ((r = this.connection) == null ? void 0 : r.readyState) < 2 && this.connection.close(), this.connection = new WebSocket(this.url + (this.api.token ? `?token=${this.api.token}` : ""));
    const t = setTimeout(() => {
      this.open || (this.connection.close(), console.error("Momentum connection timeout"), e > 0 && this.connect(e - 1));
    }, D.timeout);
    this.connection.onclose = () => this.open = !1, this.connection.onmessage = this.handle, this.connection.onopen = () => {
      this.open = !0, clearTimeout(t), console.debug("Connected to Momentum");
    };
  }
  handle(...e) {
    console.log(e);
  }
  send(e, t) {
    this.connection.send(JSON.stringify({
      token: this.api.token,
      channel: e,
      payload: t
    }));
  }
};
a(D, "timeout", 1e4);
let M = D;
class jt extends p {
  constructor(t) {
    super();
    a(this, "api");
    this.api = typeof t == "string" ? new d(t) : t;
  }
  delete(t) {
    const r = (t.startsWith("/api/storage/") ? t : "/api/storage/" + t).replaceAll("//", "/");
    return this.api.request({ url: r, method: "DELETE" }).then(() => {
      this.emit("DELETE", r);
    });
  }
  list(t) {
    const r = (t.startsWith("/api/storage/") ? t : "/api/storage/" + t).replaceAll("//", "/");
    return this.api.request({ url: r + "?list" }).then((s) => (this.emit("LIST", t, s), s));
  }
  open(t, r = "_blank") {
    const s = (t.startsWith("/api/storage/") ? t : "/api/storage/" + t).replaceAll(/\/{2,}/g, "/"), n = `${this.api.url}${s}${this.api.token ? `?token=${this.api.token}` : ""}`;
    return r ? (this.emit("OPEN", t), window.open(n, r)) : n;
  }
  mkdir(t) {
    const r = (t.startsWith("/api/storage/") ? t : "/api/storage/" + t).replaceAll(/\/{2,}/g, "/");
    return this.api.request({ url: r + "?directory", method: "POST" });
  }
  download(t, r = {}) {
    return new bt((s, n, o) => {
      const u = ("/api/storage/" + t).replaceAll("//", "/");
      this.api.request({ ...r, url: u, skipConverting: !0 }).then((c) => {
        var l;
        if (!c.ok)
          return n(c.statusText);
        const f = c.headers.get("Content-Length"), w = f ? parseInt(f, 10) : 0;
        let T = [], g = 0;
        const E = (l = c.body) == null ? void 0 : l.getReader(), _ = (F) => {
          if (F.done) {
            o(1);
            const S = new Blob(T), q = r.downloadAs || new URL(c.url).pathname.split("/").pop(), Y = URL.createObjectURL(S);
            yt(Y, q.includes(".") ? q : q + ".zip"), URL.revokeObjectURL(Y), this.emit("DOWNLOAD", t, S), s(S);
          } else {
            const S = F.value;
            T.push(S), g += S.length, o(g / w), E.read().then(_);
          }
        };
        E == null || E.read().then(_);
      });
    });
  }
  async upload(t, r = "") {
    if (t || (t = await new Promise((u) => {
      const c = document.createElement("input");
      c.type = "file", c.accept = (r == null ? void 0 : r.accept) || "*", c.style.display = "none", c.multiple = !!(r != null && r.multiple), c.onblur = c.onchange = async () => {
        u(Array.from(c.files)), c.remove();
      }, document.body.appendChild(c), c.click();
    })), !t || Array.isArray(t) && !t.length)
      return [];
    const n = new FormData(), o = ("/api/storage/" + (typeof r == "string" ? r : r == null ? void 0 : r.path)).replaceAll("//", "/");
    return (Array.isArray(t) ? t : [t]).forEach((u) => n.append("file", u)), this.api.request({ url: o, body: n }).then((u) => (this.emit("UPLOAD", u), u));
  }
}
class kt extends p {
  constructor(t) {
    super();
    a(this, "api");
    a(this, "listed", !1);
    a(this, "$cache", new I([]));
    this.api = typeof t == "string" ? new d(t) : t;
  }
  get cache() {
    return this.$cache.value;
  }
  set cache(t) {
    this.$cache.next(t);
  }
  delete(t) {
    return this.api.request({
      url: `/api/users/${t}`,
      method: "DELETE"
    }).then(() => {
      this.cache = this.cache.filter((r) => r.username != t), this.emit("DELETE", t);
    });
  }
  list(t = !1) {
    return !t && this.listed ? Promise.resolve(this.cache) : this.api.request({ url: "/api/users" }).then((r) => (this.cache = r, this.listed = !0, this.emit("LIST", r), r));
  }
  read(t, r = !1) {
    if (!r) {
      const s = this.cache.find((n) => n.username == t);
      if (s)
        return Promise.resolve(s);
    }
    return this.api.request({ url: `/api/users/${t}` }).then((s) => (s && (this.cache = { ...this.cache, [s.username]: s }), this.emit("READ", s), s));
  }
  update(t) {
    return this.api.request({
      url: `/api/users/${t.username}`,
      method: "PATCH",
      body: t
    }).then((r) => (r && (this.cache = this.cache.filter((s) => s.username != t.username).concat([r])), this.emit("UPDATE", r), r));
  }
}
class Gt extends p {
  constructor(t) {
    super();
    a(this, "api");
    a(this, "$cache", new I({}));
    this.api = typeof t == "string" ? new d(t) : t;
  }
  get cache() {
    return this.$cache.value;
  }
  set cache(t) {
    this.$cache.next(t);
  }
  list(t = !1) {
    return this.api.request({ url: "/api/settings" + (t ? "?detailed" : "") }).then((r) => (this.cache = t ? Object.values(r).reduce((s, n) => ({ ...s, [n.key]: n.value }), {}) : r, this.emit("LIST", r), r));
  }
  delete(t) {
    return this.api.request({ url: `/api/settings/${t}`, method: "DELETE" }).then(() => {
      this.cache = { ...this.cache, [t]: void 0 }, this.emit("DELETE", t);
    });
  }
  read(t, r = !1) {
    return !r && this.cache[t] ? Promise.resolve(this.cache[t]) : this.api.request({ url: `/api/settings/${t}` }).then((s) => (s && (this.cache = { ...this.cache, [s.key]: s }), this.emit("READ", s), s));
  }
  update(t) {
    return this.api.request({ url: `/api/settings/${t.key}`, body: t }).then((r) => (r && (this.cache = { ...this.cache, [r.key]: r.value }), this.emit("UPDATE", r), r));
  }
}
class Nt extends p {
  constructor(t) {
    super();
    a(this, "api");
    this.api = typeof t == "string" ? new d(t) : t;
  }
  delete(t) {
    return this.api.request({ url: `/api/static/${t}`, method: "DELETE" }).then(() => {
      this.emit("DELETE", t);
    });
  }
  list(t) {
    const r = ("/api/static/" + t).replaceAll("//", "/");
    return this.api.request({ url: r }).then((s) => (this.emit("LIST", t, s), s));
  }
  upload(t, r = "/") {
    const s = new FormData();
    return (Array.isArray(t) ? t : [t]).forEach((n) => s.append("file", n)), this.api.request({ url: "/api/static" + r, body: s }).then((n) => (this.emit("UPLOAD", n), n));
  }
}
class Wt extends p {
  constructor(t, r) {
    super();
    a(this, "api");
    a(this, "actions");
    a(this, "auth");
    a(this, "data");
    a(this, "email");
    a(this, "groups");
    a(this, "logger");
    a(this, "settings");
    a(this, "socket");
    a(this, "static");
    a(this, "storage");
    a(this, "users");
    this.api = new d(t, r == null ? void 0 : r.api), this.actions = new Pt(this.api), this.auth = new It(this.api, {
      persist: (r == null ? void 0 : r.persist) ?? !0,
      loginUi: r == null ? void 0 : r.loginUi
    }), this.data = new qt(this.api), this.email = new Ut(this.api), this.groups = new Bt(this.api), this.logger = new Ct(this.api, r == null ? void 0 : r.logLevel), this.settings = new Gt(this.api), this.static = new Nt(this.api), this.storage = new jt(this.api), this.users = new kt(this.api), r != null && r.socket && (this.socket = new M(this.api)), this.api.on("*", (s, ...n) => this.emit(`API::${s}`, ...n)), this.actions.on("*", (s, ...n) => this.emit(`ACTIONS::${s}`, ...n)), this.auth.on("*", (s, ...n) => this.emit(`AUTH::${s}`, ...n)), this.data.on("*", (s, ...n) => this.emit(`DATA::${s}`, ...n)), this.email.on("*", (s, ...n) => this.emit(`EMAIL::${s}`, ...n)), this.groups.on("*", (s, ...n) => this.emit(`GROUPS::${s}`, ...n)), this.settings.on("*", (s, ...n) => this.emit(`SETTINGS::${s}`, ...n)), this.static.on("*", (s, ...n) => this.emit(`STATIC::${s}`, ...n)), this.storage.on("*", (s, ...n) => this.emit(`STORAGE::${s}`, ...n)), this.users.on("*", (s, ...n) => this.emit(`USERS::${s}`, ...n)), this.users.on("*", (s, ...n) => {
      var o;
      if (Array.isArray(n[0])) {
        const u = n[0].find((c) => {
          var f;
          return c._id == ((f = this.auth.user) == null ? void 0 : f._id);
        });
        u && (this.auth.user = u);
      } else
        n[0]._id == ((o = this.auth.user) == null ? void 0 : o._id) && (this.auth.user = n[0]);
    });
  }
}
export {
  Dt as ActionType,
  Pt as Actions,
  d as Api,
  It as Auth,
  qt as Data,
  Ut as Email,
  Bt as Groups,
  Ct as Logger,
  Wt as Momentum,
  Gt as Settings,
  M as Socket,
  Nt as Static,
  jt as Storage,
  kt as Users
};
//# sourceMappingURL=momentum.mjs.map
